package de.unima.ki.anyburl.eval;

import java.io.IOException;
import java.util.ArrayList;

import de.unima.ki.anyburl.data.Triple;
import de.unima.ki.anyburl.data.TripleSet;

public class ComparativeEvaluation {
	
	public static String[] categories = new String[]{"Symmetry", "Equivalence", "Subsumption", "Path", "Not covered"};
	
	// YAGO03-10 FB15
	public static String target = "FB15";
	
	public static void main(String[] args) throws IOException {
		
		TripleSet trainingSet = null, validationSet = null, testSet = null;
		GoldStandard gold = null;
		
		if (target.equals("WN18")) {
			trainingSet = new TripleSet("data/WN18/train.txt");
			validationSet = new TripleSet("data/WN18/valid.txt");
			testSet = new TripleSet("data/WN18/test.txt");
			gold = new GoldStandard("data/WN18/gold.txt");
		}
		if (target.equals("FB15")) {
			trainingSet = new TripleSet("data/FB15k/train.txt");
			validationSet = new TripleSet("data/FB15k/valid.txt");
			testSet = new TripleSet("data/FB15k/test.txt");
			gold = new GoldStandard("data/FB15k/gold.txt");
		}
		
		if (target.equals("FB15-237")) {
			trainingSet =   new TripleSet("../RuleN18/data/FB15-237/train.txt");
			validationSet = new TripleSet("../RuleN18/data/FB15-237/valid.txt");
			testSet =       new TripleSet("../RuleN18/data/FB15-237/test.txt");
			gold =          new GoldStandard("../RuleN18/data/FB15-237/gold.txt");
		}
		
		if (target.equals("WN18RR")) {
			trainingSet = new TripleSet("../RuleN18/data/WN18RR/train.txt");
			validationSet = new TripleSet("../RuleN18/data/WN18RR/valid.txt");
			testSet = new TripleSet("../RuleN18/data/WN18RR/test.txt");
			gold = new GoldStandard("../RuleN18/data/WN18RR/gold.txt");
		}
		if (target.equals("YAGO03-10")) {
			trainingSet = new TripleSet("data/YAGO03-10/train.txt");
			validationSet = new TripleSet("data/YAGO03-10/valid.txt");
			testSet = new TripleSet("data/YAGO03-10/test.txt");
			gold = null;
		}
		if (target.equals("ASS")) {
			trainingSet   = new TripleSet("experiments/SemAssocs/data/empty.txt");
			validationSet = new TripleSet("experiments/SemAssocs/data/empty.txt");
			testSet       = new TripleSet("experiments/SemAssocs/data/assoc_test.nt");
			gold = null;
		}
		
		ResultSet[] results = null;
		
		
		if (target.equals("ASS")) {

			
			results = new ResultSet[]{
					
					new ResultSet("RuleN", "experiments/SemAssocs/predictions/p12-s200.txt", true, 100),
					new ResultSet("RuleN", "experiments/SemAssocs/predictions/p12-s200-mul.txt", true, 100),
					new ResultSet("RuleN", "experiments/SemAssocs/predictions/p123-s200.txt", true, 100),
					new ResultSet("RuleN", "experiments/SemAssocs/predictions/p123-s500.txt", true, 100),

					
					
			};
			
		}
		
		
		if (target.equals("YAGO03-10")) {

			
			results = new ResultSet[]{
					
					
					new ResultSet("10      ", "exp/powerslave/YAGO03-10/beta2-10", true, 10),
					new ResultSet("100     ", "exp/powerslave/YAGO03-10/beta2-100", true, 10),
					new ResultSet("1000    ", "exp/powerslave/YAGO03-10/beta2-1000", true, 10),
					new ResultSet("1000 NO ", "exp/powerslave/YAGO03-10/beta2-1000-NO", true, 10),
					new ResultSet("1000 MP ", "exp/powerslave/YAGO03-10/beta2-1000-MP", true, 10),
					new ResultSet("10000   ", "exp/powerslave/YAGO03-10/beta2-10000", true, 10),
					
	
					
			};
			
		}
		
		
		if (target.equals("WN18RR")) {

			
			results = new ResultSet[]{
	
					// from IJCAI paper
					new ResultSet("beta2-10     ", "exp/powerslave/WN18RR/beta2-10", true, 10),
					new ResultSet("beta2-100    ", "exp/powerslave/WN18RR/beta2-100", true, 10),
					new ResultSet("beta2-1000   ", "exp/powerslave/WN18RR/beta2-1000", true, 10),
					new ResultSet("beta2-1000 MP", "exp/powerslave/WN18RR/beta2-1000-MP", true, 10),
					new ResultSet("beta2-1000 NO", "exp/powerslave/WN18RR/beta2-1000-NO", true, 10),
					new ResultSet("beta2-10000  ", "exp/powerslave/WN18RR/beta2-10000", true, 10),
					
			};
			
		}
		
		if (target.equals("WN18")) {
			
			results = new ResultSet[]{

	
					new ResultSet("beta2-10    ", "exp/powerslave/WN18/beta2-10", true, 10),
					new ResultSet("beta2-100   ", "exp/powerslave/WN18/beta2-100", true, 10),
					new ResultSet("beta2-1000  ", "exp/powerslave/WN18/beta2-1000", true, 10),
					new ResultSet("beta2-1000 NO", "exp/powerslave/WN18/beta2-1000-NO", true, 10),
					new ResultSet("beta2-1000 MP", "exp/powerslave/WN18/beta2-1000-MP", true, 10),
					new ResultSet("beta2-10000 ", "exp/powerslave/WN18/beta2-10000", true, 10),
					
					
					
					// new ResultSet("alpha-y-10-u10   ", "exp/powerslave/WN18/alpha-y-10-u10", true, 10),
					// new ResultSet("alpha-y-100-u10  ", "exp/powerslave/WN18/alpha-y-100-u10", true, 10),
					// new ResultSet("alpha-y-1000-u10 ", "exp/powerslave/WN18/alpha-y-1000-u10", true, 10),
					// new ResultSet("alpha-y-10000-u10", "exp/powerslave/WN18/alpha-y-10000-u10", true, 10),
					
				
				
			};
			
		}
		
		if (target.equals("FB15-237")) {
			
			results = new ResultSet[]{
					
					// from IJCAI paper
					new ResultSet("beta2-10       ", "exp/powerslave/FB15-237/beta2-10", true, 10),
					new ResultSet("beta2-100      ", "exp/powerslave/FB15-237/beta2-100", true, 10),
					new ResultSet("beta2-1000     ", "exp/powerslave/FB15-237/beta2-1000", true, 10),
					new ResultSet("beta2-1000-MP  ", "exp/powerslave/FB15-237/gamma-1000-MP", true, 10),
					new ResultSet("beta2-1000-NO  ", "exp/powerslave/FB15-237/gamma-1000-NO", true, 10),
					new ResultSet("beta2-10000    ", "exp/powerslave/FB15-237/beta2-xx-10000", true, 10),
					//null,

					// new ResultSet("summer-500-maxplus",   "exp/summer/predictions/FB15-237-pred-500-c02-maxplus", true, 10),
					// new ResultSet("summer-500-noisyor",   "exp/summer/predictions/FB15-237-pred-500-c02-noisyor", true, 10),
					
					// new ResultSet("alpha-1000-qed  ", "exp/powerslave/FB15-237/alpha-1000-u3", true, 20),
					// new ResultSet("alpha-2000-qed  ", "exp/powerslave/FB15-237/alpha-2000-lp-u5-qed-k10", true, 20),
					
	

					
					
			};
			
		}
		
		if (target.equals("FB15")) {
			
			results = new ResultSet[]{
					

					
					// from IJCAI paper
					new ResultSet("beta2-10       ", "exp/powerslave/FB15k/beta2-10", true, 10),
					new ResultSet("beta2-100      ", "exp/powerslave/FB15k/beta2-100", true, 10),
					new ResultSet("beta2-1000     ", "exp/powerslave/FB15k/beta2-1000", true, 10),
					new ResultSet("gamma2-1000-NO ", "exp/powerslave/FB15k/gamma-1000-NO", true, 10),
					new ResultSet("gamma2-1000-MP ", "exp/powerslave/FB15k/gamma-1000-MP", true, 10),
					// new ResultSet("beta2-10000    ", "exp/powerslave/FB15k/beta2x-10000", true, 10),


					// new ResultSet("alpha-10      ", "exp/powerslave/FB15-237/alpha-10-u3", true, 20),
					//new ResultSet("alpha-10       ", "exp/powerslave/FB15k/alpha-10", true, 10),
					//new ResultSet("alpha-100      ", "exp/powerslave/FB15k/alpha-100", true, 10),
					//new ResultSet("alpha-1000     ", "exp/powerslave/FB15k/alpha-1000", true, 10),
					//new ResultSet("alpha-10000    ", "exp/powerslave/FB15k/alpha-10000", true, 10),
					//null,

			
			};
			
		}
		
		
		
		
		
		
		
		HitsAtK hitsAtK = new HitsAtK();
		
		hitsAtK.addFilterTripleSet(trainingSet);
		hitsAtK.addFilterTripleSet(validationSet);
		hitsAtK.addFilterTripleSet(testSet); 
		
		
		GoldStandard goldSymmetry    = null;	
		GoldStandard goldEquivalence = null;
		GoldStandard goldSubsumption = null;
		GoldStandard goldPath        = null;
		GoldStandard goldUncovered   = null;
		
		if (gold != null) {
			goldSymmetry    = gold.getSubset("Symmetry");	
			goldEquivalence = gold.getSubset("Equivalence");	
			goldSubsumption = gold.getSubset("Subsumption");	
			goldPath        = gold.getSubset("Path");	
			goldUncovered   = gold.getSubset("Not covered");	
		}
	

		
		for (ResultSet rs : results) {
			
			// symmetry
			
			if (rs == null) {
				System.out.print("\n------------------");
				continue;
			}
			else {
				System.out.println("");
			}
			/*
			computeScores(rs, gold, hitsAtK);
			for (int k = 0; k <= 49; k++) {
				double y = hitsAtK.getHitsAtKDouble(k);
				System.out.println(k + " " + y);
				y = y * 10 - 5.0;
				double x = (k + 1) / 5.0;
				System.out.println(x + " " + y);
				
			}
			*/
			if (gold == null) {
				computeScores(rs, testSet, hitsAtK);
				System.out.print(rs.getName() + "   " + hitsAtK.getHitsAtK(0) + "   " + hitsAtK.getHitsAtK(2) + "   " + hitsAtK.getHitsAtK(9) + "   " + hitsAtK.getApproxMRR());
				hitsAtK.reset();
			

			} else {
				
				computeScores(rs, gold, hitsAtK);
				System.out.print(rs.getName() + "   " + hitsAtK.getHitsAtK(0) + "   " + hitsAtK.getHitsAtK(2) + "   " + hitsAtK.getHitsAtK(9) + "   " + hitsAtK.getApproxMRR() + "   ");
				hitsAtK.reset();

				
				// symmetry
				computeScores(rs, goldSymmetry, hitsAtK);
				System.out.print( hitsAtK.getHitsAtK(0) + "   " + hitsAtK.getHitsAtK(9) + "   ");
				hitsAtK.reset();
				
				
				// equivalence
				computeScores(rs, goldEquivalence, hitsAtK);
				System.out.print( hitsAtK.getHitsAtK(0) + "   " + hitsAtK.getHitsAtK(9) + "   ");
				hitsAtK.reset();
				// subsumption
				computeScores(rs, goldSubsumption, hitsAtK);
				System.out.print( hitsAtK.getHitsAtK(0) + "   " + hitsAtK.getHitsAtK(9) + "   ");
				hitsAtK.reset();
				// Path
				computeScores(rs, goldPath, hitsAtK);
				System.out.print( hitsAtK.getHitsAtK(0) + "   " + hitsAtK.getHitsAtK(9) + "   ");
				hitsAtK.reset();
				// not covered
				computeScores(rs, goldUncovered, hitsAtK);
				System.out.print( hitsAtK.getHitsAtK(0) + "   " + hitsAtK.getHitsAtK(9) + "");
				hitsAtK.reset();
				
			}
			
			
			// System.out.println();
		}
		
		
		
		
		
		
	}


	private static void computeScores(ResultSet rs, GoldStandard gold, HitsAtK hitsAtK) {
		int counter = 21;
		for (String triple : gold.triples) {
			String[] tt = triple.split(" ");
			Triple t = new Triple(tt[0], tt[1], tt[2]);
			// System.out.print(t+ "\t");
			if (gold.getCategory(triple, true) != null) {
				counter++;
				ArrayList<String> cand = rs.getHeadCandidates(triple);
				// System.out.print(cand.size() + "\t");
				String c = cand.size() > 0 ? cand.get(0) : "-";
				hitsAtK.evaluateHead(cand, t);
			}
			if (gold.getCategory(triple, false) != null) {
				counter++;
				ArrayList<String> cand = rs.getTailCandidates(triple);
				// System.out.print(cand.size() + "\t");
				String c = cand.size() > 0 ? cand.get(0) : "-";
				int rank = hitsAtK.evaluateTail(cand, t);
				// if (rank == -1) System.out.println("NOT FOUND: " + triple);
			}
			// System.out.println();
		}
	}
	
	
	private static void computeScores(ResultSet rs, TripleSet gold, HitsAtK hitsAtK) {
		for (Triple t : gold.getTriples()) {
			// System.out.print(t+ "\t");
			
				if (!target.equals("ASS")) {
					ArrayList<String> cand1 = rs.getHeadCandidates(t.toString());
					// System.out.print(cand.size() + "\t");
					String c1 = cand1.size() > 0 ? cand1.get(0) : "-";
					hitsAtK.evaluateHead(cand1, t);
				}
			
				ArrayList<String> cand2 = rs.getTailCandidates(t.toString());
				// System.out.print(cand.size() + "\t");
				String c2 = cand2.size() > 0 ? cand2.get(0) : "-";
				hitsAtK.evaluateTail(cand2, t);
			// System.out.println();
		}
	}
	
	
	private static void printAndMarkUnfoundTriples(ResultSet rs, GoldStandard gold, HitsAtK hitsAtK) {
		for (String triple : gold.triples) {
			String[] tt = triple.split(" ");
			Triple t = new Triple(tt[0], tt[1], tt[2]);
			if (gold.getCategory(triple, true) != null) {
				ArrayList<String> cand = rs.getHeadCandidates(triple);
				String c = cand.size() > 0 ? cand.get(0) : "-";
				int foundAt = hitsAtK.evaluateHead(cand, t);
				if (foundAt < 0) System.out.println(t.getHead() + " headX" + t.getRelation() + " " + t.getTail());
			}
			if (gold.getCategory(triple, false) != null) {
				ArrayList<String> cand = rs.getTailCandidates(triple);
				String c = cand.size() > 0 ? cand.get(0) : "-";
				int foundAt = hitsAtK.evaluateTail(cand, t);
				if (foundAt < 0) System.out.println(t.getHead() + " tailX" + t.getRelation() + " " + t.getTail());
			}
		}
	}
	
	
	private static void compareResultSets(ResultSet rs1, ResultSet rs2, GoldStandard gold, HitsAtK hitsAtK) {
		for (String triple : gold.triples) {
			String[] tt = triple.split(" ");
			Triple t = new Triple(tt[0], tt[1], tt[2]);
			if (gold.getCategory(triple, true) != null) {
				ArrayList<String> cand1 = rs1.getHeadCandidates(triple);
				ArrayList<String> cand2 = rs2.getHeadCandidates(triple);
				boolean foundBy1 = false;
				for (String c1 : cand1) {
					if (t.getHead().equals(c1)) foundBy1 = true;
				}
				boolean foundBy2 = false;
				for (String c2 : cand2) {
					if (t.getHead().equals(c2)) foundBy2 = true;
				}
				if (foundBy1 != foundBy2) {
					System.out.println("H " + rs1.getName() + "=" + foundBy1 + " " + rs2.getName() + "=" + foundBy2 + " " + triple);
				}
				
			}
			if (gold.getCategory(triple, false) != null) {
				ArrayList<String> cand1 = rs1.getTailCandidates(triple);
				ArrayList<String> cand2 = rs2.getTailCandidates(triple);;
				boolean foundBy1 = false;
				for (String c1 : cand1) {
					if (t.getTail().equals(c1)) foundBy1 = true;
				}
				boolean foundBy2 = false;
				for (String c2 : cand2) {
					if (t.getTail().equals(c2)) foundBy2 = true;
				}
				if (foundBy1 != foundBy2) {
					System.out.println("T " + rs1.getName() + "=" + foundBy1 + " " + rs2.getName() + "=" + foundBy2 + " " + triple);
				}
			}
		}
	}

}
