package de.unima.ki.anyburl.threads;

import java.util.ArrayList;
import java.util.HashMap;

import de.unima.ki.anyburl.Apply;
import de.unima.ki.anyburl.RuleEngine;
import de.unima.ki.anyburl.Settings;
import de.unima.ki.anyburl.data.Triple;
import de.unima.ki.anyburl.data.TripleSet;
import de.unima.ki.anyburl.structure.Rule;

public class Predictor extends Thread {
	
	private TripleSet testSet;
	private TripleSet trainingSet;
	private TripleSet filterSet;
	private int k;
	private HashMap<String, ArrayList<Rule>> relation2Rules;
	
	
	public Predictor(TripleSet testSet, TripleSet trainingSet, TripleSet filterSet, int k, HashMap<String, ArrayList<Rule>> relation2Rules) {
		this.testSet = testSet;
		this.trainingSet = trainingSet;
		this.filterSet = filterSet;
		this.k = k;
		this.relation2Rules = relation2Rules;
	}
	
	
	public void run() {
		Triple triple = RuleEngine.getNextPredictionTask();
		while (triple != null) {
			if (Settings.AGGREGATION_ID == 1) RuleEngine.predictMax(testSet, trainingSet, filterSet, k, relation2Rules, triple);
			else if (Settings.AGGREGATION_ID == 2) RuleEngine.predictNoisyOr(testSet, trainingSet, filterSet, k, relation2Rules, triple);
			triple = RuleEngine.getNextPredictionTask();
			Thread.yield();
		}
		
	}

}
