package de.unima.ki.anyburl.threads;


import de.unima.ki.anyburl.Refine;
import de.unima.ki.anyburl.data.TripleSet;
import de.unima.ki.anyburl.structure.RefinedRule;

public class RScorer extends Thread {
	

	private TripleSet trainingSet;
	
	public RScorer(TripleSet trainingSet) {
		this.trainingSet = trainingSet;
	}
	
	
	public void run() {
		while (true) {
			
			RefinedRule rule = Refine.getNextRuleToBeScored();
			
			
			if (rule != null) {
				// System.out.println("trying to score refined rule " + rule);
				rule.computeScores(trainingSet);
				boolean belowLimit = Refine.addScoredRule(rule);
				if (!belowLimit) {
					try {
						// sleep because you are produding too many scored rules
						// System.out.println(" ### sleep because you are produding too many scored rules ");
						Thread.sleep(50);
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
				}
			}
			else {
				try {
					// sleep because there is nothing left to be done
					// System.out.println(" ### sleep because there is nothing left to be done ");
					// System.out.println("thread going to sleep " + System.currentTimeMillis());
					Thread.sleep(100);
					
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
			if (Refine.finished()) {
				System.out.println("* ... scorer thread deactivated.");
				return;
			}
		}
	}
}
