package de.unima.ki.anyburl.threads;


import de.unima.ki.anyburl.Learn;
import de.unima.ki.anyburl.data.TripleSet;
import de.unima.ki.anyburl.structure.Rule;

public class Scorer extends Thread {
	

	private TripleSet trainingSet;
	
	public Scorer(TripleSet trainingSet) {
		this.trainingSet = trainingSet;
	}
	
	
	public void run() {
		while (true) {
			Rule rule = Learn.getNextRuleToBeScored();
			
			if (rule != null) {
				rule.computeScores(trainingSet);
				boolean belowLimit = Learn.addScoredRule(rule);
				if (!belowLimit) {
					try {
						// sleep because you are produding too many scored rules
						// System.out.println(" ### sleep because you are produding too many scored rules ");
						Thread.sleep(50);
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
				}
			}
			else {
				try {
					// sleep because there is nothing left to be done
					// System.out.println(" ### sleep because there is nothing left to be done ");
					Thread.sleep(100);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
			if (Learn.finished()) {
				System.out.println("* ... scorer thread deactivated.");
				return;
			}
		}
	}
}
